'StayConnected.vbs: Connect to the specified station, then re-connect automatically if dropped

'Author: Jonathan Taylor, K1RFD
'Date: July 23, 2003

'To invoke this script from the command line, type:
'	cscript StayConnected.vbs callsign
'where "callsign" is the callsign of the station to which to connect.


If WScript.Arguments.Count > 0 Then

	sStation = WScript.Arguments(0)

	'Instantiate EchoLink's Session component, and set up an event connection
	Set oEchoLink = WScript.CreateObject("EchoLink.EchoLinkSession", "EchoLink_")
	
	bConnected = False

	While True

		'try to connect
		On Error Resume Next
		Err.Clear
		WScript.Echo "Attempting connect..."
		oEchoLink.Connect sStation, True
		If Err <> 0 Then
			WScript.Echo "Connect failed: " & Err.Description
			'wait 10 secs and try again
			WScript.Sleep 10000
		Else
			On Error Goto 0
			WScript.Echo "Connected to " & sStation
			bConnected = True

			'go to sleep until we get disconnected
			While bConnected
				WScript.Sleep 2000
			Wend

			WScript.Sleep 5000
		End If
	Wend	
End If


Sub EchoLink_Closing
	'EchoLink is shutting down; exit now to avoid picking daisies
	WScript.Echo "EchoLink exiting"
	Set oEchoLink = Nothing
	WScript.Quit(0)
End Sub


Sub EchoLink_Disconnected(sDisconnectingStation)

	'Who just disconnected?  If it was the one we're watching, notify the main loop

	If sDisconnectingStation = sStation Then 
		WScript.Echo "Disconnected: " & sStation
		bConnected = False
	End If

End Sub

